/*
 * This Java source file was generated by the Gradle 'init' task.
 */
package nl.wur.ssb.tests;

import nl.wur.ssb.DomainPatternRecognition.*;
import nl.wur.ssb.DomainPatternRecognition.commandOptions.CommandOptions;
import nl.wur.ssb.DomainPatternRecognition.objects.Operon;
import org.apache.commons.io.FileUtils;
import org.apache.log4j.Level;
import org.apache.spark.SparkConf;
import org.apache.spark.api.java.JavaSparkContext;
import org.junit.Test;

import java.io.File;
import java.util.Arrays;
import java.util.HashMap;

import static org.junit.Assert.assertTrue;

public class AppTest {
    private JavaSparkContext sc;

    private void setUpSC () {
        if (sc == null) {
            SparkConf sConf = new SparkConf();
            sConf.setMaster("local[1]"); // I'M ASSUMING ONE JOB HERE.
            // sConf.setMaster("spark://SSB130062.local:7077");
            sConf.setAppName("SAPP HDT Query");
            sConf.set("spark.executor.memory", "5g");
            sConf.set("", "");
            // Submits itself with the SPARK job...
            sConf.set("spark.jars", "HDTQuery.jar");

            // set input to recursive.
            sConf.set("spark.hadoop.mapreduce.input.fileinputformat.input.dir.recursive", "true");
            sConf.set("spark.hive.mapred.supports.subdirectories", "true");

            sc = new JavaSparkContext(sConf);
            sc.setCheckpointDir(DomainPatternRecognition.checkPointDirectory);
        }
    }


    @Test
    public void testMain() throws Exception {
//        String[] args = {"-domain","PF01016", "-outputDirectory", "/home/sanne/Documents/genomedufs_spark/Output", "-recursiveInput", "-inputDirectory", "./data/test"}; // original one
//        String[] args = {"-domain", "PF02287", "-outputDirectory", "/home/sanne/Documents/genomedufs_spark/Output", "-recursiveInput", "-inputDirectory", "./data/test, -bidirectional"};
//       String[] args = {"-domain","PF04542", "-outputDirectory", "/home/sanne/Documents/genomedufs_spark/Output", "-recursiveInput", "-inputDirectory", "./data/test"};
        String[] args = {"-domain","PF00005",
                "-outputDirectory", "/home/sanne/Documents/genomedufs_spark/OutputTest_10-02-20",
                "-recursiveInput",
                "-inputDirectory", "./data/test",
                "-minSupportFPMValues", "0.1",
                "-regionWidth", "20000",
                "-doFrequentPatternMining"
//                "-geneGap" , "40"
        };
        App.main(args);
    }



    @Test
    public void testMainSmallSet() throws Exception{
        String[] args = {"-domain","PF00465", "-outputDirectory", "/home/sanne/Documents/genomedufs_spark/testOutput", "-recursiveInput", "-inputDirectory", "./13PDOData", "-minSupportFPMValues", "0.15", "-bidirectional",
                "-bidirectionalGapMinimum", "50", // todo change back to serious value.
                "-bidirectionalGapMaximum", "1000",
        "-threads", "4",
//        "-LDAClusteringFPM" // this one works
//                "-getAssociationRules" // this one works
//                "-LDAClusteringOperons" // this one works

        };
        App.main(args);
    }

    @Test
    public void testFMPNetWork() throws Exception{
        String[] args = {"-domain","PF00465", "-outputDirectory", "/home/sanne/Documents/genomedufs_spark/13PDOData_graphXoutput", "-recursiveInput", "-inputDirectory", "./13PDOData",
        "-minSupportFPMValues", "0.15", "-bidirectional",
                "-bidirectionalGapMinimum", "50", // todo change back to serious value.
                "-bidirectionalGapMaximum", "1000",
                "-geneGap" , "500",
                "-threads", "4",
                "-networkCutOff", "0.5",
                "-doFrequentPatternMining",
                "-FPMNetwork"};

        App.main(args);
    }


    /**
     * A test to check whether all operons do contain the domain of interest after the
     * @throws Exception
     */
    @Test
    public void testOperonsOnAllContainingDOI() throws Exception {
        String[] args = {"-domain","PF00465",
                "-outputDirectory", "/home/sanne/Documents/genomedufs_spark/testOutput",
                "-recursiveInput",
                "-inputDirectory", "./13PDOData",
                "-LDAVocabSize" , "5",
                "-LDAClustersFP" , "6", // original values
                "-LDAClustersOperons" , "5",
                "-minSupportFPMValues", "0.9",
                "-bidirectional",
                "-bidirectionalGap", "100",
                "-geneGap", "50",
                "-detectTraits"
        };

        CommandOptions commandOptions = new CommandOptions(args);
        setUpSC();
        DomainPatternRecognition domainPatternRecognition = new DomainPatternRecognition(commandOptions,sc);
        domainPatternRecognition.queryInputData("PF00465", true); // todo also change domain here when changing it in the command options.
        HashMap<String, Operon> operonHashMap = domainPatternRecognition.getOperonHashMap();

        // test whether all the operons contain the domain of interest
        for (String key : operonHashMap.keySet()) {
            Operon operon = operonHashMap.get(key);
            assert operon.getDomains().contains("PF00465");
        }

        JavaSparkContext sc = domainPatternRecognition.getSc();
//        FreqPatternsParallel freqPatternsParallel = new FreqPatternsParallel(commandOptions, sc, operonHashMap);
//        freqPatternsParallel.runFrequencyPatternMining();

    }

    /**
     * This test checkes whether the input data is queried again. It should not requery when the output directory is
     * changed, but this seems to be the case before developing this test.
     */
    @Test
    public void testChangingOutputDirectoryRequery() throws Exception {
        String[] args1 = {"-domain","PF00465",
                "-outputDirectory", "/home/sanne/Documents/genomedufs_spark/testOutput",
                "-recursiveInput",
                "-inputDirectory", "./data/test",
                "-LDAVocabSize" , "5",
                "-LDAClustersFP" , "6", // original values
                "-LDAClustersOperons" , "5",
                "-minSupportFPMValues", "0.9",
                "-bidirectional",
                "-bidirectionalGap", "100",
                "-geneGap", "50",
                "-detectTraits"
        };

        CommandOptions commandOptions = new CommandOptions(args1) ;

        // create the output directory
        String lookupPath = "/home/sanne/Documents/genomedufs_spark/LookUpFiles";
        File LookUpDir = new File(lookupPath);
        File outputDir = new File("/home/sanne/Documents/genomedufs_spark/testOutput");

        if (LookUpDir.exists()) {
            FileUtils.cleanDirectory(new File(lookupPath));
        }
        if (!outputDir.exists()) {
            boolean success = outputDir.mkdirs();
        }
//        SPARQLQueryInput.main(commandOptions);
//        assert !SPARQLQueryInput.isDomainDescriptionPresent();
//        assert !SPARQLQueryInput.isDomainFrequenciesPresent();
//        assert SPARQLQueryInput.isNecessaryToQueryRegions();

        // Now do it again with a different output folder.
        String[] args2 = {"-domain","PF00465",
                "-outputDirectory", "/home/sanne/Documents/genomedufs_spark/testOutput2",
                "-recursiveInput",
                "-inputDirectory", "./data/test",
                "-LDAVocabSize" , "5",
                "-LDAClustersFP" , "6", // original values
                "-LDAClustersOperons" , "5",
                "-minSupportFPMValues", "0.9",
                "-bidirectional",
                "-bidirectionalGap", "100",
                "-geneGap", "50",
                "-detectTraits"
        };

        CommandOptions commandOptions2 = new CommandOptions(args2) ;
        File outputDir2 = new File("/home/sanne/Documents/genomedufs_spark/testOutput2");
        if (!outputDir.exists()) {
            boolean success = outputDir.mkdirs();
        }

//        SPARQLQueryInput.main(commandOptions2);
//        assert SPARQLQueryInput.isDomainDescriptionPresent();
//        assert SPARQLQueryInput.isDomainFrequenciesPresent();
//        assert !SPARQLQueryInput.isNecessaryToQueryRegions();
    }

    @Test
    public void testAdditionalDomainsCommandOptions() throws Exception {
        String[] args = {"-domain","PF02287",
                "-outputDirectory", "/home/sanne/Documents/genomedufs_spark/testOutput2",
                "-recursiveInput",
                "-inputDirectory", "./data/test",
                "-minSupportFPMValues", "0.5",
                "-additionalDomains", "PF03928"
        };

        CommandOptions commandOptions = new CommandOptions(args);
        org.apache.log4j.Logger.getLogger("org.apache.spark").setLevel(Level.OFF);
        setUpSC();

        DomainPatternRecognition domainPatternRecognition = new DomainPatternRecognition(commandOptions, sc);
        HashMap<String, Operon> operonHashMap = domainPatternRecognition.queryInputData("PF02287", true);
        for (String key : operonHashMap.keySet()) {
            System.out.println(operonHashMap.get(key).getDomains());
            assert operonHashMap.get(key).getDomains().containsAll(Arrays.asList("PF02287", "PF03928") );
        }

    }

    @Test
    public void testOneFileAsInput() throws Exception {
        String[] args = {"-domain","PF02287",
                "-outputDirectory", "/home/sanne/Documents/genomedufs_spark/testOutput2",
                "-recursiveInput",
                "-inputDirectory", "./data/test/GCA_001626685.1.prodigal.interproscan.hdt",
                "-minSupportFPMValues", "0.5",
                "-additionalDomains", "PF03928"
        };
        App.main(args);
    }

    @Test
    public void testMultipleInputDirectories() throws Exception {
        String[] args = {"-domain","PF02287",
                "-outputDirectory", "/home/sanne/Documents/genomedufs_spark/testOutput2",
//                "-recursiveInput",
                "-inputDirectory", "./data/test,./data/test/TestRecursive",
                "-minSupportFPMValues", "0.5",
                "-additionalDomains", "PF03928"
        };
        App.main(args);

    }

    @Test
    public void testNoOperonsFound() throws Exception {
        String[] args = {"-domain","PFdoesnotexist",
                "-outputDirectory", "/home/sanne/Documents/genomedufs_spark/testOutput2",
                "-inputDirectory", "./data/test,./data/test/TestRecursive",
                "-minSupportFPMValues", "0.5",
                "-doFrequentPatternMining"

        };
        App.main(args);
    }


}
